
#include "NalParser.h"

int
main(int argc, char * argv[]) {
  if (argc != 2) {
	printf("Usage: NalParserApp h.264file\n");
	return 1;
  }

  NalParser parser(argv[1]);
  unsigned char * naldata = new unsigned char [1000000];

  uint32 nNalSize;
  do {
	// this is first part, should contain nal header etc...
	int bReadMore = parser.getNextNal(naldata, 1000000, &nNalSize);
	
	// check that we actually start with a startcode...
	if (!(naldata[0] == 0 && naldata[1] == 0 && naldata[2] == 0 && naldata[3] == 1)) {
	  printf("nal should start with 0x00000001 rather than 0x%02x%02x%02x%02x...\n",
			 naldata[0], naldata[1], naldata[2], naldata[3]);
	} else {
	  printf("naltype: %d size=%d\n", naldata[4]&0x1f, nNalSize );
	  for (int i = 0; i < 8; i++) {
		  printf(" %02x", naldata[i]);
	  }
	  printf("\n");
	}

	while (bReadMore) {
	  bReadMore = parser.getNextNal(naldata, 1000000, &nNalSize);
	}
  } while (nNalSize > 0);
  delete [] naldata;
  return 0;
}
	
